/*     
   Je 5 domů, z nichž každý má jinou barvu.
   V každém domě žije jeden člověk, který pochází z jiného státu.
   Každý člověk pije nápoj, kouří jeden druh cigaret a chová jedno zvíře.
   Žádný z nich nepije stejný nápoj, nekouří stejný druh cigaret a nechová
   stejné zvíře.

  1   Brit bydlí v červeném domě.
  2   Švéd chová psa.
  3   Dán pije čaj.
  4   Zelený dům stojí hned nalevo od bílého.
  5   Majitel zeleného domu pije kávu.
  6   Ten, kdo kouří PallMall, chová ptáka.
  7   Majitel žlutého domu kouří Dunhill.
  8   Ten, kdo bydlí uprostřed řady domů, pije mléko.
  9   Nor bydlí v prvním domě.
  10  Ten, kdo kouří Blend, bydlí vedle toho, kdo chová kočku.
  11  Ten, kdo chová koně, bydlí vedle toho, kdo kouří Dunhill.
  12  Ten, kdo kouří BlueMaster, pije pivo.
  13  Němec kouří Prince.
  14  Nor bydlí vedle modrého domu.
  15  Ten, kdo kouří Blend, má souseda, který pije vodu.

Kdo má rybičky?
*/


isLeftTo(X,Y,SX,SY)
 :- SX = [X,_,_,_,_], SY = [_,Y,_,_,_];
    SX = [_,X,_,_,_], SY = [_,_,Y,_,_];
    SX = [_,_,X,_,_], SY = [_,_,_,Y,_];
    SX = [_,_,_,X,_], SY = [_,_,_,_,Y].

isNextTo(X,Y,SX,SY)
 :- isLeftTo(X,Y,SX,SY);
    isLeftTo(Y,X,SY,SX).

isTogetherWith(X,Y,SX,SY)
 :- SX = [X,_,_,_,_], SY = [Y,_,_,_,_];
    SX = [_,X,_,_,_], SY = [_,Y,_,_,_];
    SX = [_,_,X,_,_], SY = [_,_,Y,_,_];
    SX = [_,_,_,X,_], SY = [_,_,_,Y,_];
    SX = [_,_,_,_,X], SY = [_,_,_,_,Y].

reseni(B,N,Z,P,K) 
    :-

/*  8   Ten, kdo bydlí uprostřed řady domů, pije mléko. */
    P = [_,_,mleko,_,_],

/*  9   Nor bydlí v prvním domě. */
    N = [nor,_,_,_,_],

/*  4   Zelený dům stojí hned nalevo od bílého. */
    isLeftTo(zelena,bila,B,B),

/*  1   Brit bydlí v červeném domě. */
    isTogetherWith(brit,cervena,N,B),

/*  14  Nor bydlí vedle modrého domu. */
    isNextTo(nor,modra,N,B),

/*  2   Švéd chová psa. */
    isTogetherWith(sved,pes,N,Z),

/*  6   Ten, kdo kouří PallMall, chová ptáka. */
    isTogetherWith(pallmall,ptak,K,Z),

/*  7   Majitel žlutého domu kouří Dunhill. */
    isTogetherWith(zluta,dunhill,B,K),

/*  10  Ten, kdo kouří Blend, bydlí vedle toho, kdo chová kočku. */
    isNextTo(blend,kocka,K,Z),

/*  11  Ten, kdo chová koně, bydlí vedle toho, kdo kouří Dunhill. */
    isNextTo(kun,dunhill,Z,K),

/*  13  Němec kouří Prince. */
    isTogetherWith(nemec,prince,N,K),

/*  5   Majitel zeleného domu pije kávu. */
    isTogetherWith(zelena,kava,B,P),

/*  3   Dán pije čaj. */
    isTogetherWith(dan,caj,N,P),

/*  12  Ten, kdo kouří BlueMaster, pije pivo. */
    isTogetherWith(bluemaster,pivo,K,P),

/*  15  Ten, kdo kouří Blend, má souseda, který pije vodu. */
    isNextTo(blend,voda,K,P).


rybicky(X) :-
reseni(_,[X,_,_,_,_],[rybicky,_,_,_,_],_,_);
reseni(_,[_,X,_,_,_],[_,rybicky,_,_,_],_,_);
reseni(_,[_,_,X,_,_],[_,_,rybicky,_,_],_,_);
reseni(_,[_,_,_,X,_],[_,_,_,rybicky,_],_,_);
reseni(_,[_,_,_,_,X],[_,_,_,_,rybicky],_,_).

/*
alternativne:
 rybicky(X) :- reseni(_,N,Z,_,_), isTogetherWith(X,rybicky,N,Z). 
*/ 
